"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var test = require("tape");
var DelugeClient_1 = require("./DelugeClient");
require('util.promisify/shim')();
var path = require("path");
var fs = require("fs");
var util = require("util");
var sinon = require("sinon");
test('DelugeClient.connect() - connects to a daemon', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var client;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                client = new DelugeClient_1.default({ host: 'localhost', port: 8112, password: 'deluge' });
                return [4, client.connect()];
            case 1:
                _a.sent();
                t.pass('should connect');
                t.end();
                return [2];
        }
    });
}); });
test('DelugeClient.getTorrents() - returns an empty list', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var client, torrents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                client = new DelugeClient_1.default({ host: 'localhost', port: 8112, password: 'deluge' });
                return [4, client.connect()];
            case 1:
                _a.sent();
                return [4, client.getTorrents()];
            case 2:
                torrents = _a.sent();
                t.is(torrents.length, 0, 'should return empty list');
                t.end();
                return [2];
        }
    });
}); });
test('DelugeClient.addFiles() - adds torrents', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var readFile, client, archlinux_torrent, ubuntu_torrent, torrents, _a, _b, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                readFile = util.promisify(fs.readFile);
                client = new DelugeClient_1.default({ host: 'localhost', port: 8112, password: 'deluge' });
                return [4, client.connect()];
            case 1:
                _d.sent();
                archlinux_torrent = path.join(__dirname, '../../torrents/archlinux-2017.10.01-x86_64.iso.torrent');
                ubuntu_torrent = path.join(__dirname, '../../torrents/ubuntu-17.10-desktop-amd64.iso.torrent');
                _b = (_a = client).addFiles;
                _c = [archlinux_torrent];
                return [4, readFile(ubuntu_torrent, { encoding: null })];
            case 2: return [4, _b.apply(_a, [_c.concat([_d.sent()]), {
                        directory: path.join(__dirname, '../../torrents/target'),
                        tempDirectory: path.join(__dirname, '../../torrents/temp')
                    }])];
            case 3:
                torrents = _d.sent();
                t.is(torrents.length, 2, 'should return 2 torrents');
                t.is(torrents[0].hash, '9228628504cc40efa57bf38e85c9e3bd2c572b5b', 'should have the right hashes');
                t.is(torrents[1].hash, '40448d478d9203a3919b0900e7fbb9e8748dcdf9', 'should have the right hashes');
                t.end();
                return [2];
        }
    });
}); });
test('DelugeClient.getTorrents() - returns the newly added torrents', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var client, torrents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                client = new DelugeClient_1.default({ host: 'localhost', port: 8112, password: 'deluge' });
                return [4, client.connect()];
            case 1:
                _a.sent();
                return [4, client.getTorrents()];
            case 2:
                torrents = _a.sent();
                t.is(torrents.length, 2, 'should only return two torrents');
                t.is(torrents[0].name, 'ubuntu-17.10-desktop-amd64.iso', 'should have the torrent name');
                t.is(torrents[1].name, 'archlinux-2017.10.01-x86_64.iso', 'should have the torrent name');
                t.end();
                return [2];
        }
    });
}); });
test('DelugeTorrent.liveFeed() - emits events', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var hash, timeout, client, torrent;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                hash = '9228628504cc40efa57bf38e85c9e3bd2c572b5b';
                timeout = util.promisify(setTimeout);
                client = new DelugeClient_1.default({ host: 'localhost', port: 8112, password: 'deluge' });
                return [4, client.connect()];
            case 1:
                _a.sent();
                return [4, client.getTorrent(hash)];
            case 2:
                torrent = _a.sent();
                torrent.on('resume', function () {
                    t.pass("'resume' called");
                    torrent.on('finish', function () {
                        t.pass("'finish' called");
                        t.end();
                    });
                });
                torrent.on('pause', function () {
                    t.pass("'pause' called");
                    setTimeout(function () {
                        torrent.resume();
                    }, 600);
                });
                torrent.liveFeed(200);
                return [4, timeout(500)];
            case 3:
                _a.sent();
                torrent.pause();
                return [2];
        }
    });
}); });
test('DelugeTorrent.remove() - removes torrents with data', function (t) { return __awaiter(_this, void 0, void 0, function () {
    var readdir, unlink, timeout, client, torrents, stub, emptyTorrents, target, temp, downloads, temps, ops;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                readdir = util.promisify(fs.readdir);
                unlink = util.promisify(fs.unlink);
                timeout = util.promisify(setTimeout);
                client = new DelugeClient_1.default({ host: 'localhost', port: 8112, password: 'deluge' });
                return [4, client.connect()];
            case 1:
                _a.sent();
                return [4, client.getTorrents()];
            case 2:
                torrents = _a.sent();
                t.is(torrents.length, 2, 'should return all the torrents');
                stub = sinon.stub();
                torrents[0].on('remove', stub);
                torrents[0].liveFeed();
                return [4, Promise.all(torrents.map(function (t) { return t.remove(true); }))];
            case 3:
                _a.sent();
                return [4, client.getTorrents()];
            case 4:
                emptyTorrents = _a.sent();
                t.is(emptyTorrents.length, 0, 'should return no torrents once removed');
                return [4, timeout(3200)];
            case 5:
                _a.sent();
                target = path.join(__dirname, '../../torrents/target');
                temp = path.join(__dirname, '../../torrents/temp');
                return [4, readdir(target)];
            case 6:
                downloads = _a.sent();
                t.deepEqual(downloads, ['.gitignore'], 'should have removed the downloaded files');
                return [4, readdir(temp)];
            case 7:
                temps = _a.sent();
                ops = temps.filter(function (f) { return f !== '.gitignore'; }).map(function (f) { return unlink(path.join(temp, f)); });
                return [4, Promise.all(ops)];
            case 8:
                _a.sent();
                t.true(stub.calledOnce, "'removed' called");
                t.end();
                return [2];
        }
    });
}); });
//# sourceMappingURL=DelugeClient.test.js.map